<?php
//-----------------------------------------------------------------------------------
/**
*  ws  
*/
//   
function consolestart(){
	consolemsg("console - start");
}

//
function consolemsg($msg, $ignoredirectoutput = false){
	$file = null;
	if(!file_exists($GLOBALS['ws']['logfile'])) {
	    $file = fopen($GLOBALS['ws']['logfile'],"w");
//		fputs($file, "<!DOCTYPE html>\r\n<html>\r\n<head>\r\n<title>GC - console log</title>\r\n\r\n<meta charset=\"UTF-8\" />\r\n</head>\r\n<body>\r\n"); //   ..       div
	}else
	    $file = fopen($GLOBALS['ws']['logfile'],"a");
	
	
	if( function_exists('memory_get_usage') ) $msg = "Mem: ".memory_get_usage()." bytes ".$msg;

	if(!$ignoredirectoutput) { echo $msg."\r\n"; }

	fputs ($file, "[<b>".date("Y.m.d-H:i:s")."</b>]". $msg ."<br />\r\n"); 
	fclose($file); 
}

// 
function consoleend(){
	consolemsg("console - end");
}

//-----------------------------------------------------------------------------------
/**
*    
*/
function getstatusfwithconsole($pidfile) {
  if( file_exists($pidfile) ) {
    $pid = file_get_contents($pidfile);
    //  
	$status = getstatusp($pid);
    if($status['run']) { 
	  //  
	  consolemsg("daemon already running info=".$status['info']);
      return true;
    } else {
      //pid- ,   
      consolemsg("there is no process with PID = ".$pid.", last termination was abnormal...");
      consolemsg("try to unlink PID file...");
      if(!unlink($pidfile)) {
	    consolemsg("ERROR");
        //   pid-. 
        exit(-1);
      }
      consolemsg("OK");
    }
  }
  return false;
}

//-----------------------------------------------------------------------------------
/**
*   ,   pid,  -1     , -2      
*/
function getstatusf($pidfile) {

  if( file_exists($pidfile) ) {

	$pid = file_get_contents($pidfile);
	$output = null;

	if (strtoupper(substr(PHP_OS,0,3)) === 'WIN'){ 
		exec("tasklist /fi \"pid eq ".$pid."\"", $output);

		if(count($output)>3){//         ! ..    ,    
			return $pid;
		} else {
		  //pid- ,   
		   return -2;
		}
	} else {// *nix
		exec("ps -aux -p ".$pid, $output);
		
		if(count($output)>1){//         ! ..    ,    
			return $pid;
		} else {
		  //pid- ,   
		   return -2;
		}
	}
  }
  return -1;//   

}

//-----------------------------------------------------------------------------------
/**
*     *nix
*/
function getstatusp($pid) {
	$result = array ('run'=>false);
	$output = null;

	if (strtoupper(substr(PHP_OS,0,3)) === 'WIN'){ 
		exec("tasklist /fi \"pid eq ".$pid."\"", $output);

		if(count($output)>3){//         ! ..    ,    
			$result['run'] = true;
			$result['info'] = $output[3];//    
		} 
	} else {// *nix
		exec("ps -aux -p ".$pid, $output);

		if(count($output)>1){//         ! ..    ,    
			$result['run'] = true;
			$result['info'] = $output[1];//    
		}
	}

	return $result;
}

//-----------------------------------------------------------------------------------
/**
*    JSON    ,     ws
*/
function json_statusf($pidfile) {

  if( file_exists($pidfile)  ) {
    $pid = file_get_contents($pidfile);
	$output = null;

	if (strtoupper(substr(PHP_OS,0,3)) === 'WIN'){ // Windows  ,   PID     , ..    
		exec("tasklist /fi \"pid eq ".$pid."\"", $output);

		if(count($output)>3){//         ! ..    ,    
			echo "{color:\"green\",msg:\"WINDOWS:[<b>".date("Y.m.d-H:i:s")."</b>] ws server is running with PID =".$pid." ws://".$GLOBALS['ws']['addr'].":".$GLOBALS['ws']['port']."<br />";
			echo mb_convert_encoding($output[1], "utf-8", "cp866")."<br />";//    
			echo mb_convert_encoding($output[3], "utf-8", "cp866")."\"}";//    
			
			//consolemsg("MSG FROM WIN ".$output[1].$output[2], true);
			return;
		} else {
		  //pid- ,   
		  echo  "{color:\"red\",msg:\"WINDOWS:[<b>".date("Y.m.d-H:i:s")."</b>] ws server is down cause abnormal reason with PID =".$pid."<br />\"}";
		  return;
		}
	}

	//  
	exec("ps -aux -p ".$pid, $output);
    
	if(count($output)>1){//         ! ..    ,    
		echo "{color:\"green\",msg:\"*NIX:[<b>".date("Y.m.d-H:i:s")."</b>] ws server is running with PID =".$pid."<br />ws://".$GLOBALS['ws']['addr'].":".$GLOBALS['ws']['port']."<br />";
		echo $output[0]."<br />";//    
		echo $output[1]."\"}";//    
		return;
	} else {
      //pid- ,   
	  echo  "{color:\"red\",msg:\"*NIX:[<b>".date("Y.m.d-H:i:s")."</b>] ws server is down cause abnormal reason with PID =".$pid."<br />\"}";
	  return;
    }
  }

  if (strtoupper(substr(PHP_OS,0,3)) === 'WIN') // Windows  ,   PID     , ..    
		echo "{color:\"grey\",msg:\"WINDOWS:[<b>".date("Y.m.d-H:i:s")."</b>] ws server is off, press start<br />ws://".$GLOBALS['ws']['addr'].":".$GLOBALS['ws']['port']."\"}";
  else 	 
		echo "{color:\"grey\",msg:\"*NIX:[<b>".date("Y.m.d-H:i:s")."</b>] ws server is off, press start<br />ws://".$GLOBALS['ws']['addr'].":".$GLOBALS['ws']['port']."\"}";

}

//-----------------------------------------------------------------------------------
/**
*    
*/
function test_var_value($variable){//  test_var
    	if (!isset($variable) ) //   
    		return "undefined";

    	$res="";
    	if (is_null($variable) ){ // NULL
    		$res.="NULL";
    	}elseif (is_callable($variable)){
    		$res.= "<b>callable</b> ";
    		if (is_string($variable)){
    		    $functions = get_defined_functions();
    		    $res.= array_search($variable, $functions['internal'])? 'internal':'user';
    		    $res.= ' function '.htmlspecialchars($variable).'()';
    		} elseif (is_array($variable)){
    		    reset($variable);
    		    $class  = current($variable);
    		    $method = next($variable);
    		    if (is_string($class))      {  $res.= 'static class '.$class.'::'.$method.'()';				 }
    		    elseif (is_object($class))	 {  $res.= 'object of class '.get_class($class).'->'.$method.'()';	 }
    		    else						 {  $res.= 'unknown "'.strval($variable).'"';						 }
    		} else {
    		    $res.= 'unknown "'.strval($variable).'"';
    		}
    	}elseif ( is_array($variable) ){// ,   
    		$res.="<b>array</b>";
    		$res.="<ul>";
    		foreach( $variable as $key => $value ){
    			$res.="<li>";
    			$res.="[ ".test_var_value($key)." ] = ".test_var_value($value);
    			$res.="</li>";
    		}
    		$res.="</ul>";
    	}elseif (is_int($variable)){
    		$res.="<b>integer</b> ";
    		$res.=$variable;
    	}elseif (is_bool($variable)){
    		$res.="<b>bool</b>";
    		if ( $variable )
    			$res.="<i>True</i>";
    		else
    			$res.="<i>False</i>";
    	}elseif (is_string($variable)){
    		$res.= "<b>string</b>[".strlen($variable)."] ";
    		$res.= "\"".htmlspecialchars($variable)."\"";
    	}elseif (is_float($variable)){
    		$res.= "<b>float</b> ";
    		$res.= $variable;
    	}elseif (is_resource($variable)){
    		$res.= "<b>resource</b> ";
    		$res.= '"'.get_resource_type($variable).'"';
    	}elseif (is_object($variable)  ){
    		$res.= "<b>object</b>[".get_class($variable)."] ";
    		$res.= print_r($variable,1);
    	}else{
         $res.= "<b>Unknown type</b>";
    	}
    	return $res;
}


?>